

#    AGATA Digitizer Application Implementation file

    package require DataAcquisitionControlServer   ;# load generic code


proc do_Implementation-SetUp {args} {after 1000 executeSetUp}

proc do_Implementation-Reset {args} {
     global MIDAS_DataAcquisitionCode

     set MIDAS_DataAcquisitionCode 2
}

proc do_Implementation-Stop {args} {
     global MIDAS_DataAcquisitionCode

     set MIDAS_DataAcquisitionCode 0
}

proc do_Implementation-Go {args} {
     global MIDAS_DataAcquisitionCode

     set MIDAS_DataAcquisitionCode 1
}

proc do_Implementation-Counters {args} {
       global MIDAS_DataAcquisitionCounters
   return 0
}

proc do_Implementation-Rates {args} {
       global MIDAS_DataAcquisitionRates
   return 0
}

proc do_Implementation-GetState {args} {
}

proc do_Implementation-SetOption {state option value} {after 1000 executeOption $state $option $value}

proc do_Implementation-GetOption {args} {
}

proc executeSetUp {} {
       global errorCode errorInfo
       global MIDAS_DataAcquisitionCode MIDAS_DataAcquisitionState MIDAS_DataAcquisitionReason
       global MIDAS_DataAcquisitionError MIDAS_DataAcquisitionInfo

        set rc [catch {AGATADigitizer::do_SetUpAllDigitizers} m]

        if {$rc != 0} {

            puts "SETUP returned with an error\n$m\n$errorCode\n$errorInfo"

            set MIDAS_DataAcquisitionCode 6
            set MIDAS_DataAcquisitionError 4096
            set MIDAS_DataAcquisitionInfo "$m\n$errorCode\n$errorInfo"
        } else {

            set MIDAS_DataAcquisitionCode 0
        }
}

proc executeOption {state option value} {
       global errorCode errorInfo
       global MIDAS_DataAcquisitionCode MIDAS_DataAcquisitionState MIDAS_DataAcquisitionReason
       global MIDAS_DataAcquisitionError MIDAS_DataAcquisitionInfo
       global MIDAS_DataAcquisitionControlServer_Verbose
       if {$MIDAS_DataAcquisitionControlServer_Verbose} {puts "called method executeOption with args $state $option $value"}

       switch $option {
           ReSync {
              switch $value {
                 All -
                 ALL {set rc [catch {AGATADigitizer::do_ReSyncAllDigitizers} m]}
                 default {set rc [catch {AGATADigitizer::do_ReSyncDigitizer $value} m]}
              }
              set MIDAS_DataAcquisitionCode $state
           }
           SetUp {
              switch $value {
                 All -
                 ALL {set rc [catch {AGATADigitizer::do_SetUpAllDigitizers} m]}
                 default {set rc [catch {AGATADigitizer::do_SetUpDigitizer $value} m]}
              }
              set MIDAS_DataAcquisitionCode $state
           }
           State {
              set MIDAS_DataAcquisitionCode $value
              set rc 0
           }
           default {
              puts "called method executeOption with args $state $option $value"
              set MIDAS_DataAcquisitionCode $state
              set rc 0
           }
       }

        if {$rc != 0} {

            puts "OPTION returned with an error\n$m\n$errorCode\n$errorInfo"

            set MIDAS_DataAcquisitionCode 6
            set MIDAS_DataAcquisitionError 4096
            set MIDAS_DataAcquisitionInfo "$m\n$errorCode\n$errorInfo"
        }

       if {$MIDAS_DataAcquisitionControlServer_Verbose} \
             {puts "exit method executeOption with MIDAS_DataAcquisitionCode $MIDAS_DataAcquisitionCode"}
}

package provide AGATADigitizerControl 1.0
